unit MySIVCManual;

interface

	uses
		MyOldSIVC;
		
	procedure StartupSIVCManual;
	procedure ConfigureSIVCManual(mcresult: SIVCManualQueryCallBack);
	
implementation

	uses
		MyFMenus, MyMenus, MyStartup;

	var
		mcresult_callback : SIVCManualQueryCallBack;

	procedure DoSIVCManual;
	begin
		ManualQuery(mcresult_callback);
	end;
	
	procedure SetSIVCManual(themenu, theitem:integer);
	begin
		SetIDItemEnable(themenu, theitem, CanManualQuery);
	end;
	
	function InitSIVCManual(var msg: integer): OSStatus;
	begin
{$unused(msg)}
		SetFBoth('sivc',DoSIVCManual,SetSIVCManual);
		InitSIVCManual := noErr;
	end;
	
	procedure ConfigureSIVCManual(mcresult: SIVCManualQueryCallBack);
	begin
		StartupSIVCManual;
		mcresult_callback := mcresult;
	end;
	
	procedure StartupSIVCManual;
	begin
		StartupFMenus;
		StartupSIVC;
		SetStartup(InitSIVCManual, nil, 0, nil);
	end;
	
end.
