unit MyTextEdit;

interface

	uses
		Types, TextEdit;
	
	function HasTEGetHiliteRgn: Boolean;
	function PtInTEHiliteRgn( localwhere: Point; te: TEHandle ): Boolean;
	
implementation

{ Some routines based on John Norstad's NewsWatcher source code }

	uses
		GestaltEqu, Quickdraw;
		
	function HasTEGetHiliteRgn: Boolean;
		var
			gv: longint;
	begin
		HasTEGetHiliteRgn := (Gestalt(gestaltTEAttr, gv) = noErr) & btst(gv, gestaltTEHasGetHiliteRgn);
	end;
	
	function PtInTEHiliteRgn( localwhere: Point; te: TEHandle ): Boolean;
		var
			rgn: RgnHandle;
	begin
		PtInTEHiliteRgn := false;
		if HasTEGetHiliteRgn then begin
			rgn := NewRgn;
			if TEGetHiliteRgn( rgn, te ) = noErr then begin
				PtInTEHiliteRgn := PtInRgn( localwhere, rgn );
			end;
			DisposeRgn( rgn );
		end;
	end;
	
end.