unit NSSpriteWorld8BitBlitters;

interface

{ interface to C code blitters }

	uses
		Types;
		
	type
		PixelChunkPtr = ^UInt32;
	
	procedure BlitPixie8Bit(
		srcPixelP: PixelChunkPtr; 
		dstPixelP: PixelChunkPtr; 
		rowsToCopy: UInt32; 
		numBytesPerRow: UInt32; 
		srcRowBytes: UInt32;
		dstRowBytes: UInt32); C;

	procedure BlitPixieMask8Bit(
		srcPixelP: PixelChunkPtr; 
		dstPixelP: PixelChunkPtr; 
		maskPixelP: PixelChunkPtr; 
		rowsToCopy: UInt32; 
		numBytesPerRow: UInt32; 
		srcRowBytes: UInt32;
		dstRowBytes: UInt32); C;

	procedure BlitPixiePartialMask8Bit(
		srcPixelP: PixelChunkPtr; 
		dstPixelP: PixelChunkPtr; 
		maskPixelP: PixelChunkPtr; 
		rowsToCopy: UInt32; 
		numBytesPerRow: UInt32; 
		srcRowBytes: UInt32;
		dstRowBytes: UInt32); C;

end.