unit Messages;

interface
	uses
{$IFC UNDEFINED THINK_PASCAL}
		MacIntf,
{$ENDC}
		TransEdit, TransDisplay, TransSkel;

	var
		messagesWind: WindowPtr; {Initialized from the main program}

	procedure WriteMessage (msg: Str255);
	procedure WriteLnMessage;
	procedure WriteMessageLine (msg: Str255);

implementation

	var
		messageBuffer: Str255;

	procedure WriteMessage (msg: Str255);
	begin
		if Length(messageBuffer) + Length(msg) < 255 then
			messageBuffer := ConCat(messageBuffer, msg)
		else
			begin
				ShowWindow(messagesWind);
				SelectWindow(messagesWind);
				DisplayString(messageBuffer);
				messageBuffer := msg;
			end;
	end;

	procedure WriteLnMessage;
	begin
		ShowWindow(messagesWind);
		SelectWindow(messagesWind);
		SetDWindow(messagesWind);
		messageBuffer := ConCat(messageBuffer, Char(13));
		DisplayString(messageBuffer);
		messageBuffer := '';
	end; {WriteLnMessage}

	procedure WriteMessageLine (msg: Str255);
	begin
		WriteMessage(msg);
		WriteLnMessage;
	end; {WriteMessageLine}


end.