unit MoreFinderEvents.p;

interface

	uses
		Types, Aliases;

	function MFE_Reveal( what: AliasHandle ): OSErr;
	function MFE_PutAway( what: AliasHandle ): OSErr;
	function MFE_OpenGetInfo( what: AliasHandle ): OSErr;
	function MFE_OpenSharing( what: AliasHandle ): OSErr;
	function MFE_CloseWindow( what: AliasHandle ): OSErr;
	function MFE_CloseGetInfo( what: AliasHandle ): OSErr;
	function MFE_CloseSharing( what: AliasHandle ): OSErr;
	function MFE_MakeAlias( what: AliasHandle ): OSErr;
	function MFE_Duplicate( what: AliasHandle ): OSErr;
	function MFE_OpenSelection( what: AliasHandle ): OSErr;
	function MFE_PrintSelection( what: AliasHandle ): OSErr;
	function MFE_PageSetup( what: AliasHandle ): OSErr;
	function MFE_PrintWindow( what: AliasHandle ): OSErr;

	function MFE_Move( aliasToDrag: AliasHandle, destAlias: AliasHandle ): OSErr;
	function MFE_Copy( aliasToDrag: AliasHandle, destAlias: AliasHandle ): OSErr;

	function MFE_UnmountVolume( vRefNum: integer ): OSErr;

	function MFE_ShowClipboard: OSErr;
	function MFE_HideClipboard: OSErr;
	function MFE_ShowAbout: OSErr;
	function MFE_HideAbout: OSErr;
	function MFE_Sleep: OSErr;
	function MFE_Restart: OSErr;
	function MFE_ShutDown	: OSErr;
	function MFE_EmptyTrash: OSErr;

end.
