unit MySocks;

interface

	uses
		Types;

	const
		socks_default_port = 1080;
		socks_version = 4;

	const { Response commands/codes }
		socks_connect = 1;
		socks_bind = 2;
		socks_result = 90;
		socks_fail = 91;

{$PUSH}
{$ALIGN MAC68K}

	type
		SocksRecordSmall = packed record
				version: Byte;
				cmd: Byte;
				port: integer;
				ip: longint;
			end;
		SocksRecord = packed record
				version: Byte;
				cmd: Byte;
				port: integer;
				ip: longint;
				name: Str63; {cstring!}
			end;

{$ALIGN RESET}
{$POP}

implementation

end.
